//+------------------------------------------------------------------
//|
//+------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1  clrCadetBlue
#property indicator_color2  clrIndianRed
#property indicator_color3  clrDodgerBlue
#property indicator_color4  clrTomato
#property indicator_width3  1
#property indicator_width4  1
#property indicator_level1   60.0
#property indicator_level2   50.0
#property indicator_level3  -50.0
#property indicator_level4  -60.0
#property indicator_minimum -100.0
#property indicator_maximum  100.0
#property strict

//
//
//
//
//

extern ENUM_TIMEFRAMES TimeFrame          = PERIOD_CURRENT; // Time frame to use
extern int             WavePeriod         = 3;              // Wave period
extern int             AvgPeriod          = 7;              // Average period
extern int             Envelope_Period    = 100;            // Envelope period
extern double          Envelope_Deviation = 0.1;            // Envelope deviations
extern double          LowLevel           = -50;            // Low level test value
extern double          HighLevel          =  50;            // High level test value
extern bool            alertsOn           = false;          // Turn alerts on?
extern bool            alertsOnCurrent    = true;           // Alerts on current (still opened) bar?
extern bool            alertsMessage      = true;           // Alerts should display a message?
extern bool            alertsSound        = false;          // Alerts should play a sound?
extern bool            alertsEmail        = false;          // Alerts should send an email?
extern bool            alertsPush         = false;          // Alerts should send a push notification?
extern bool            Interpolate        = true;           // Interpolate in multi time frame mode?

double value[],signal[],arrBuy[],arrSell[];
double work1[],work2[],work3[],work4[];
string indicatorFileName;
bool   returnBars;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init() {
   IndicatorBuffers(8);
   SetIndexBuffer(0,value);
   SetIndexBuffer(1,signal);
   SetIndexBuffer(2,arrBuy);  SetIndexStyle(2,DRAW_ARROW); SetIndexArrow(2,108);
   SetIndexBuffer(3,arrSell); SetIndexStyle(3,DRAW_ARROW); SetIndexArrow(3,108);
   SetIndexBuffer(4,work1);
   SetIndexBuffer(5,work4);
   SetIndexBuffer(6,work2);
   SetIndexBuffer(7,work3);
         indicatorFileName = WindowExpertName();
         returnBars        = (TimeFrame==-99);
         TimeFrame         = MathMax(TimeFrame,_Period);
   return (0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start() 
{
   int counted_bars=IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars > 0) counted_bars--;
            int limit  = MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) {value[0] = limit+1; return(0); }
           if (TimeFrame!=_Period)
           {
               limit = (int)MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period()));
               for(int i=limit; i>=0; i--)
               {
                  int y = iBarShift(NULL,TimeFrame,Time[i]);
                  int x = iBarShift(NULL,TimeFrame,Time[MathMin(i+1,Bars-1)]);
                     value[i]   = iCustom(NULL,TimeFrame,indicatorFileName,0,WavePeriod,AvgPeriod,Envelope_Period,Envelope_Deviation,LowLevel,HighLevel,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,alertsPush,0,y);
                     signal[i]  = iCustom(NULL,TimeFrame,indicatorFileName,0,WavePeriod,AvgPeriod,Envelope_Period,Envelope_Deviation,LowLevel,HighLevel,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,alertsPush,1,y);
                     arrBuy[i]  = EMPTY_VALUE;
                     arrSell[i] = EMPTY_VALUE;
                     if (x!=y)
                     {
                        arrBuy[i]  = iCustom(NULL,TimeFrame,indicatorFileName,0,WavePeriod,AvgPeriod,Envelope_Period,Envelope_Deviation,LowLevel,HighLevel,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,alertsPush,2,y);
                        arrSell[i] = iCustom(NULL,TimeFrame,indicatorFileName,0,WavePeriod,AvgPeriod,Envelope_Period,Envelope_Deviation,LowLevel,HighLevel,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,alertsPush,3,y);
                     }
                     if (!Interpolate || (i>0 && y==iBarShift(NULL,TimeFrame,Time[i-1]))) continue;
                  
                     //
                     //
                     //
                     //
                     //
                  
                     int n,k; datetime time = iTime(NULL,TimeFrame,y);
                        for(n = 1; (i+n)<Bars && Time[i+n] >= time; n++) continue;	
                        for(k = 1; k<n && (i+n)<Bars && (i+k)<Bars; k++) 
                        {
                           value[i+k]  = value[i]  + (value[i+n]  - value[i] ) * k/n;
                           signal[i+k] = signal[i] + (signal[i+n] - signal[i]) * k/n;
                        }
               }
               return(0);
          }               
            
   //
   //
   //
   //
   //
               
   for (int i = limit; i > 0; i--) work1[i]  = iMA(NULL,0,WavePeriod,0,MODE_EMA,PRICE_TYPICAL, i);
   for (int i = limit; i > 0; i--) work4[i]  = MathAbs((High[i]+Close[i]+Low[i])/3.0-work1[i]);
   for (int i = limit; i > 0; i--) work2[i]  = iMAOnArray(work4,0,WavePeriod,0,MODE_EMA,i);;
   for (int i = limit; i > 0; i--) work3[i]  = (work2[i] != 0.0) ? ((High[i]+Close[i]+Low[i])/3.0-work1[i])/(0.015*work2[i]) : 0;
   for (int i = limit; i > 0; i--) value[i]  = iMAOnArray(work3,0,AvgPeriod,0,MODE_EMA,i);
   for (int i = limit; i > 0; i--) signal[i] = iMAOnArray(value,0,        4,0,MODE_SMA,i);
   for (int i = limit; i > 0; i--) 
   {
      arrBuy[i]  = EMPTY_VALUE;
      arrSell[i] = EMPTY_VALUE;
         if (i<Bars-1 && value[i]>=signal[i] && value[i+1]<=signal[i+1] && value[i]<LowLevel)
         if (Low[i]<iEnvelopes(NULL,0,Envelope_Period,MODE_SMA,0,PRICE_CLOSE,Envelope_Deviation,MODE_LOWER,i)) arrBuy[i] = value[i];
         
         if (i<Bars-1 && value[i]<=signal[i] && value[i+1]>=signal[i+1] && value[i]>HighLevel)
         if (High[i]>iEnvelopes(NULL,0,Envelope_Period,MODE_SMA,0,PRICE_CLOSE,Envelope_Deviation,MODE_UPPER,i)) arrSell[i] = signal[i];
   }
   manageAlerts();
   return (0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      int whichBar = 1; if (alertsOnCurrent) whichBar = 0;
      
      //
      //
      //
      //
      //
      
      static datetime time1 = 0;
      static string   mess1 = "";
         if (arrBuy[whichBar] != EMPTY_VALUE || arrSell[whichBar]!=EMPTY_VALUE)
         {
            if (arrBuy [whichBar] !=  EMPTY_VALUE) doAlert(time1,mess1,whichBar," signal buy");
            if (arrSell[whichBar] !=  EMPTY_VALUE) doAlert(time1,mess1,whichBar," signal sell");
         }            
   }
}   

//
//
//
//
//

void doAlert(datetime& previousTime, string& previousAlert, int forBar, string doWhat)
{
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message = _Symbol+" "+timeFrameToString(_Period)+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+doWhat;
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(_Symbol+" signals",message);
             if (alertsPush)    SendNotification(message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}

//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}